package com.example.showprogressbar;

import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.ProgressBar;

public class MainActivity extends AppCompatActivity {
    private static final int MAX_LOOP = 6;  // 非同期処理内のループ数
    private ProgressBar mProgressBar = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        mProgressBar = (ProgressBar)findViewById(R.id.progressBarHor);
        // 初期状態ではプログレスバーを非表示に
        mProgressBar.setVisibility(View.GONE);
        mProgressBar.setIndeterminate(false);
        mProgressBar.setMax(MAX_LOOP);
        // ボタンの処理：非同期処理を開始する
        findViewById(R.id.button).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                // プログレスバーを更新する非同期処理を開始。
                new MyTask().execute();
            }
        });
    }
    class MyTask extends AsyncTask<Void, Integer, Void> {
        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            mProgressBar.setProgress(0);    // プログレスバーの状態をリセット
            mProgressBar.setVisibility(View.VISIBLE);
        }

        @Override
        protected Void doInBackground(Void... params) {
            for(int i = 0; i <= MAX_LOOP; ++i){
                publishProgress(i); // onProgressUpdate()にループ数を渡す
                try{
                    // ダミー処理。実際はここでダウンロードなどの処理を実装する
                    Thread.sleep(500);
                }catch (Exception e){}
            }
            return null;
        }

        @Override
        protected void onProgressUpdate(Integer... values) {
            super.onProgressUpdate(values); // ProgressBarの表示を更新する
            // プログレスバーの進捗状態を進める
            mProgressBar.setProgress(values[0]);
        }

        @Override
        protected void onPostExecute(Void aVoid) {
            super.onPostExecute(aVoid);
            // 非同期処理終了、ProgressBarを消す
            mProgressBar.setVisibility(View.GONE);
        }
    }
}
