package com.example.showprogresstext;

import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity {
    TextView label = null;
    MyTask myTask = null;
    int counter = 0;
    private static final int MAX_LOOP = 12; // 非同期処理内のループ数

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        // 画面上のTextViewを取得する。ここにAsyncTaskの実行結果を表示する
        label = (TextView)findViewById(R.id.textView1);
        // ボタンの処理：非同期処理を開始する
        findViewById(R.id.button1).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                new MyTask().execute();
            }
        });
    }

    class MyTask extends AsyncTask<Void, Integer, Void> {
        @Override
        protected Void doInBackground(Void... params) {
            try{
                for(int i = 0; i < MAX_LOOP; ++i){
                    Thread.sleep(500);
                    publishProgress(1 + i); // 画面上のlabelを更新する
                }
            }catch(InterruptedException e){
            }
            return null;
        }
        @Override
        protected void onProgressUpdate(Integer... values) {
            super.onProgressUpdate(values);
            label.setText("処理:" + values[0] + "/" + MAX_LOOP);
        }
        @Override
        protected void onPostExecute(Void aVoid) {
            super.onPostExecute(aVoid);
            label.setText("非同期処理終了");
        }
    }
}
