package com.example.splashstart;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;

public class MainActivity extends AppCompatActivity {

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // SharedPreferencesからフラグを取得
        // 初期化処理が完了しているかを判定する
        SharedPreferences prefs = getSharedPreferences("settings", Activity.MODE_PRIVATE);

        // 初期化できていない場合
        // スプラッシュ画面に遷移し、スプラッシュ画面表示中に初期化する
        if(!prefs.getBoolean("initFlg", false)){
            Intent splashIntent = new Intent(MainActivity.this, SplashActivity.class);
            startActivity(splashIntent);
            finish();
        }else{
            setContentView(R.layout.activity_main);
        }
    }
}
