package com.example.usecursorloader;

import android.app.ListActivity;
import android.app.LoaderManager;
import android.content.ContentValues;
import android.content.CursorLoader;
import android.content.Loader;
import android.database.Cursor;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.SimpleCursorAdapter;

public class MyListActivity extends ListActivity implements LoaderManager.LoaderCallbacks<Cursor>{
    private SimpleCursorAdapter mAdapter;

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        Log.v("MyListActivity", "onCreateOptionsMenu");
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // メニューからでなくても、ContentProviderの処理は他の操作からも呼び出し可能
        ContentValues values = new ContentValues();
        values.put(MyDBHelper.COLUMN_NAME, "TEST");
        getContentResolver().insert(MyProvider.CONTENT_URI, values);
        return true;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        mAdapter = new SimpleCursorAdapter(this,
                android.R.layout.simple_expandable_list_item_1,
                null,
                new String[]{MyDBHelper.COLUMN_NAME},
                new int[]{android.R.id.text1},
                0
        );
        setListAdapter(mAdapter);
        // Loaderの初期化。
        getLoaderManager().initLoader(0, null, this);
    }

    @Override
    public Loader<Cursor> onCreateLoader(int id, Bundle args) {
        return new CursorLoader(this, MyProvider.CONTENT_URI, null, null, null, null);
    }

    @Override
    public void onLoadFinished(Loader<Cursor> loader, Cursor cursor) {
        mAdapter.swapCursor(cursor);
    }

    @Override
    public void onLoaderReset(Loader<Cursor> loader) {
        mAdapter.swapCursor(null);
    }
}
