package com.example.usecursorloader;

import android.content.ContentProvider;
import android.content.ContentUris;
import android.content.ContentValues;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.net.Uri;
import android.support.annotation.Nullable;

// データベース値のやり取りに使用するContentProviderを定義
public class MyProvider extends ContentProvider {
    public static final Uri CONTENT_URI = Uri.parse("content://com.example.myprovider");

    // 以下、データ操作の各種メソッド
    @Override
    public int delete(Uri uri, String selection, String[] selectionArgs) {
        return 0;
    }

    @Nullable
    @Override
    public String getType(Uri uri) {
        return null;
    }

    @Nullable
    @Override
    public Uri insert(Uri uri, ContentValues values) {
        MyDBHelper dbHelper = new MyDBHelper(getContext());
        SQLiteDatabase db = dbHelper.getWritableDatabase();
        long rowId = db.insert(MyDBHelper.TABLE_NAME, null, values);
        if (rowId > 0) {
            Uri returnUri = ContentUris.withAppendedId(CONTENT_URI, rowId);
            getContext().getContentResolver().notifyChange(returnUri, null);
            return returnUri;
        }
        return null;
    }

    @Override
    public boolean onCreate() {
        return true;
    }

    @Nullable
    @Override
    public Cursor query(Uri uri, String[] projection, String selection, String[] selectionArgs, String sortOrder) {
        MyDBHelper dbHelper = new MyDBHelper(getContext());
        SQLiteDatabase db = dbHelper.getReadableDatabase();
        Cursor c = db.rawQuery("SELECT "
                + MyDBHelper.COLUMN_ID + ", "
                + MyDBHelper.COLUMN_NAME + " from "
                + MyDBHelper.TABLE_NAME + ";", null
        );
        c.setNotificationUri(getContext().getContentResolver(), uri);
        return c;
    }

    @Override
    public int update(Uri uri, ContentValues values, String selection, String[] selectionArgs) {
        return 0;
    }
}
