package com.example.sendmultidata;

import android.app.ActivityManager;
import android.content.Context;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.List;

public class Utils {
    // 特定の日時の通算ミリ秒を受け取り、書式を整えて文字列として返す
    public static String formatDate(long timeMs){
        Calendar cal = Calendar.getInstance();
        cal.setTimeInMillis(timeMs);
        SimpleDateFormat dateTemplate = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss.SSS");
        return dateTemplate.format(cal.getTime()).toString();
    }

    // 指定したファイルに文字列データを追記する。成功した場合はtrueを返す
    public static boolean appendToFile(Context context, String fileName, String saveValue){
        FileOutputStream out = null;
        try {
            // 追記モードでファイルを開く
            out = context.openFileOutput(fileName, Context.MODE_PRIVATE | Context.MODE_APPEND);
            out.write(saveValue.getBytes());
            out.close();
            return true;
        } catch (FileNotFoundException e) {
            // 指定されたファイルが見付からなかった場合
        } catch (IOException e) {
            // 入出力系エラー
        }
        return false;
    }

    // 指定したファイルのサイズを取得する
    public static long getFileSize(Context context, String fileName){
        File targetFile = null;
        targetFile = context.getFileStreamPath(fileName);
        // FileInputStream#available()より正確なサイズが取得できるFile#length()を使用。
        return targetFile.length();
    }

    // サービスが起動中か確認する。実行中のサービス一覧を取得して、その中から探す
    public static boolean isServiceRunning(Context context, String serviceClassName){
        ActivityManager am = (ActivityManager)context.getSystemService(Context.ACTIVITY_SERVICE);
        List<ActivityManager.RunningServiceInfo> rs = am.getRunningServices(Integer.MAX_VALUE);
        for(ActivityManager.RunningServiceInfo thisSvcInfo : rs){
            if(thisSvcInfo.service.getClassName().equals(serviceClassName)){
                return true;
            }
        }
        return false;
    }
}
