package com.example.usebackoff;

import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;

public class MainActivity extends AppCompatActivity {
    private static final String TAG = "MainActivity";
    private Button button = null;
    private boolean isRetryOn = false;
    private Intent serviceIntent = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        isRetryOn = (BackgroundService.getBackoff(this) > 0);

        // Service起動用Intent。
        serviceIntent = new Intent(this, BackgroundService.class);

        // UI部品取得。
        button = (Button)findViewById(R.id.button1);

        // ボタンをタップした時の動作を定義
        button.setOnClickListener(new View.OnClickListener(){
            public void onClick(View view) {
                isRetryOn = (BackgroundService.getBackoff(MainActivity.this) > 0);

                // リトライ有効→リトライを止める
                if(isRetryOn){
                    Log.v(TAG, "リトライ停止");
                    BackgroundService.setBackoff(MainActivity.this, 0);
                }
                // リトライ無効→バックグラウンド処理開始
                else{
                    BackgroundService.setBackoff(MainActivity.this, BackgroundService.INITIAL_BACKOFF_MS);
                    startService(serviceIntent);
                }

                // 状態をトグル
                isRetryOn = !isRetryOn;
                // ボタンのラベルを切り替え（実行・停止）
                button.setText((isRetryOn)? R.string.button_label_stop : R.string.button_label_exec);
            }
        });
    }
}
