package com.example.usejobscheduler;

import android.app.job.JobInfo;
import android.app.job.JobScheduler;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;

/*
 * JobSchedulerで「ネットワークが利用可能になったら実行」という設定でジョブをスケジューリングする
 */
public class MainActivity extends AppCompatActivity {
    private static final String TAG = MainActivity.class.getSimpleName();
    private ComponentName mComponentName = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        mComponentName = new ComponentName(this, MyJobService.class);

        findViewById(R.id.button).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                JobScheduler scheduler = (JobScheduler)getSystemService(Context.JOB_SCHEDULER_SERVICE);
                JobInfo jobInfo = new JobInfo.Builder(0, mComponentName)    // 第一引数はジョブID
                        .setMinimumLatency(1000)    // 条件が揃ってからジョブ実行までの最低待ち時間
                        .setRequiredNetworkType(JobInfo.NETWORK_TYPE_ANY)
                        .build();
                scheduler.schedule(jobInfo);
                Log.v(TAG, "scheduled");
            }
        });
    }
}
