package com.example.presenterpattern.model;

import com.example.presenterpattern.presenter.MainPresenterCallback;
import com.example.presenterpattern.util.ZipCodeUtil;

import rx.Observable;
import rx.Subscriber;
import rx.android.schedulers.AndroidSchedulers;
import rx.schedulers.Schedulers;

public class MainBusinessLogic {
    public void convertLogic(final MainPresenterCallback mainActivity, final String zipCode) {
        Observable.create(new Observable.OnSubscribe<AddressItem>() {
            @Override
            public void call(Subscriber<? super AddressItem> subscriber) {
                AddressItem item = new AddressItem(ZipCodeUtil.convertAddress(zipCode));
                subscriber.onNext(item);
                subscriber.onCompleted();
            }})
                .subscribeOn(Schedulers.newThread())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(new Subscriber<AddressItem>() {
                    @Override
                    public void onCompleted() {
                    }
                    @Override
                    public void onError(Throwable e) {
                    }
                    @Override
                    public void onNext(AddressItem item) {
                        if (item == null || "-".equals(item.name)) {
                            mainActivity.showErrorMessage("登録されていない住所です");
                        } else {
                            mainActivity.showAddress(item);
                        }
                    }
        });
    }
}
