package com.example.presenterpattern.view;

import android.support.annotation.Nullable;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import com.example.presenterpattern.R;
import com.example.presenterpattern.model.AddressItem;
import com.example.presenterpattern.presenter.MainPresenter;
import com.example.presenterpattern.presenter.MainPresenterCallback;

public class MainActivity extends AppCompatActivity implements MainPresenterCallback {

    TextView mTextView;

    private static MainPresenter presenter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        presenter = new MainPresenter(this);
        mTextView = (TextView) findViewById(R.id.text);
        findViewById(R.id.button).setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                presenter.convert("163-1490");
            }
        });
    }
    @Override
    public void showAddress(@Nullable AddressItem item) {
        mTextView.setText(item.name);
    }

    @Override
    public void showErrorMessage(String message) {
        Toast.makeText(MainActivity.this, message, Toast.LENGTH_SHORT).show();
    }
}
